#include <iostream>
#include "Koordinate.h"
#include "Niz.h"

using namespace std;

int main(int argc, char** argv) {
	int n;
	cout<<"Dimenzija niza: "<<endl;
	cin>>n;
	//prosledjujemo parametar sablona klase
	Niz<int> nizInt(n);
	Niz<float> nizFloat(n);
	Niz<Koordinate> nizKoordinata(n);

	cout<<"Unesi cele brojeve:"<<endl;
	nizInt.ucitaj();
	cout<<"Unesi realne brojeve:"<<endl;
	nizFloat.ucitaj();
	cout<<"Unesi koordinate:"<<endl;
	nizKoordinata.ucitaj();
	
	cout<<"Celi brojevi:"<<endl;
	nizInt.ispisi();
	cout<<"Realni brojevi:"<<endl;
	nizFloat.ispisi();
	cout<<"Koordinate:"<<endl;
	nizKoordinata.ispisi();
	
	Koordinate maks = nizKoordinata.maksimalni();
	cout<<"Maksimalni element celih brojeva je: "<<nizInt.maksimalni()<<endl;
	cout<<"Maksimalni element realnih brojeva je: "<<nizFloat.maksimalni()<<endl;
	cout<<"Maksimalna koordinata je: "<<maks<<endl;
	
	cout<<"Prosecni element celih brojeva je: "<<nizInt.prosek()<<endl;
	cout<<"Prosecni element realnih brojeva je: "<<nizFloat.prosek()<<endl;
	cout<<"Prosecna koordinata je: "<<nizKoordinata.prosek()<<endl;

	// ne moramo da pozivamo eksplicitno brisanje jer ce se na kraju pozvati automatski destruktor
	// za nizInt, nizFloat i nizKoordinata objekte, a on ce u okviru sebe da izvrsi destrukciju
	// svojih unutrasnje kreiranih dinamickih elemenata, u ovom slucaju samo internog niza pozivom delete [] niz
	return 0;
}
